OSDN Git Service

Merge commit 'remotes/korg/cupcake'
[android-x86/dalvik.git] / tests / run-test
1 #!/bin/bash
2 #
3 # Copyright (C) 2007 The Android Open Source Project
4 #
5 # Licensed under the Apache License, Version 2.0 (the "License");
6 # you may not use this file except in compliance with the License.
7 # You may obtain a copy of the License at
8 #
9 #     http://www.apache.org/licenses/LICENSE-2.0
10 #
11 # Unless required by applicable law or agreed to in writing, software
12 # distributed under the License is distributed on an "AS IS" BASIS,
13 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14 # See the License for the specific language governing permissions and
15 # limitations under the License.
16
17 # Set up prog to be the path of this script, including following symlinks,
18 # and set up progdir to be the fully-qualified pathname of its directory.
19 prog="$0"
20 while [ -h "${prog}" ]; do
21     newProg=`/bin/ls -ld "${prog}"`
22     newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
23     if expr "x${newProg}" : 'x/' >/dev/null; then
24         prog="${newProg}"
25     else
26         progdir=`dirname "${prog}"`
27         prog="${progdir}/${newProg}"
28     fi
29 done
30 oldwd=`pwd`
31 progdir=`dirname "${prog}"`
32 cd "${progdir}"
33 progdir=`pwd`
34 prog="${progdir}"/`basename "${prog}"`
35
36 export JAVA="java"
37 export JAVAC="javac -target 1.5"
38 export RUN="${progdir}/etc/push-and-run-test-jar"
39
40 info="info.txt"
41 build="build"
42 run="run"
43 expected="expected.txt"
44 output="output.txt"
45 build_output="build-output.txt"
46 run_args="--quiet"
47
48 dev_mode="no"
49 update_mode="no"
50 debug_mode="no"
51 usage="no"
52
53 while true; do
54     if [ "x$1" = "x--local" ]; then
55         RUN="${progdir}/etc/local-run-test-jar"
56         shift
57     elif [ "x$1" = "x--reference" ]; then
58         RUN="${progdir}/etc/reference-run-test-classes"
59         shift
60     elif [ "x$1" = "x--fast" ]; then
61         run_args="${run_args} --fast"
62         shift
63     elif [ "x$1" = "x--portable" ]; then
64         run_args="${run_args} --portable"
65         shift
66     elif [ "x$1" = "x--debug" ]; then
67         run_args="${run_args} --debug"
68         shift
69     elif [ "x$1" = "x--gdb" ]; then
70         run_args="${run_args} --gdb"
71         dev_mode="yes"
72         shift
73     elif [ "x$1" = "x--zygote" ]; then
74         run_args="${run_args} --zygote"
75         shift
76     elif [ "x$1" = "x--no-verify" ]; then
77         run_args="${run_args} --no-verify"
78         shift
79     elif [ "x$1" = "x--no-optimize" ]; then
80         run_args="${run_args} --no-optimize"
81         shift
82     elif [ "x$1" = "x--valgrind" ]; then
83         run_args="${run_args} --valgrind"
84         shift
85     elif [ "x$1" = "x--dev" ]; then
86         dev_mode="yes"
87         shift
88     elif [ "x$1" = "x--update" ]; then
89         update_mode="yes"
90         shift
91     elif [ "x$1" = "x--help" ]; then
92         usage="yes"
93         shift
94     elif expr "x$1" : "x--" >/dev/null 2>&1; then
95         echo "unknown option: $1" 1>&2
96         usage="yes"
97         break
98     else
99         break
100     fi
101 done
102
103 if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
104     echo "--dev and --update are mutually exclusive" 1>&2
105     usage="yes"
106 fi
107
108 if [ "$usage" = "no" ]; then
109     if [ "x$1" = "x" -o "x$1" = "x-" ]; then
110         test_dir=`basename "$oldwd"`
111     else
112         test_dir="$1"
113     fi
114
115     if [ '!' -d "$test_dir" ]; then
116         td2=`echo ${test_dir}-*`
117         if [ '!' -d "$td2" ]; then
118             echo "${test_dir}: no such test directory" 1>&2
119             usage="yes"
120         fi
121         test_dir="$td2"
122     fi
123
124     # Shift to get rid of the test name argument. The rest of the arguments
125     # will get passed to the test run.
126     shift
127 fi
128
129 if [ "$usage" = "yes" ]; then
130     prog=`basename $prog`
131     (
132         echo "usage:"
133         echo "  $prog --help                          Print this message."
134         echo "  $prog [options] [test-name]           Run test normally."
135         echo "  $prog --dev [options] [test-name]     Development mode" \
136             "(dumps to stdout)."
137         echo "  $prog --update [options] [test-name]  Update mode" \
138             "(replaces expected.txt)."
139         echo '  Omitting the test name or specifying "-" will use the' \
140             "current directory."
141         echo "  Runtime Options:"
142         echo "    --fast         Use the fast interpreter (the default)."
143         echo "    --portable     Use the portable interpreter."
144         echo "    --debug        Wait for a debugger to attach."
145         #echo "    --gdb          Run under gdb; incompatible with some tests."
146         echo "    --no-verify    Turn off verification (on by default)."
147         echo "    --no-optimize  Turn off optimization (on by default)."
148         echo "    --zygote       Spawn the process from the Zygote." \
149             "If used, then the"
150         echo "                   other runtime options are ignored."
151         echo "    --local        Use a host-local virtual machine."
152         echo "    --valgrind     Use valgrind when running locally."
153         echo "    --reference    Use a host-local reference virtual machine."
154     ) 1>&2
155     exit 1
156 fi
157
158 cd "$test_dir"
159 test_dir=`pwd`
160
161 td_info="${test_dir}/${info}"
162 td_expected="${test_dir}/${expected}"
163
164 tmp_dir="/tmp/test-$$"
165
166 if [ '!' '(' -r "$td_info" -a -r "$td_expected" ')' ]; then
167     echo "${test_dir}: missing files" 1>&2
168     exit 1
169 fi
170
171 # copy the test to a temp dir and run it
172
173 echo "${test_dir}: running..." 1>&2
174
175 rm -rf "$tmp_dir"
176 cp -Rp "$test_dir" "$tmp_dir"
177 cd "$tmp_dir"
178
179 if [ '!' -r "$build" ]; then
180     cp "${progdir}/etc/default-build" build
181 fi
182
183 if [ '!' -r "$run" ]; then
184     cp "${progdir}/etc/default-run" run
185 fi
186
187 chmod 755 "$build"
188 chmod 755 "$run"
189
190 good="no"
191 if [ "$dev_mode" = "yes" ]; then
192     "./${build}" 2>&1
193     echo "build exit status: $?" 1>&2
194     "./${run}" $run_args "$@" 2>&1
195     echo "run exit status: $?" 1>&2
196     good="yes"
197 elif [ "$update_mode" = "yes" ]; then
198     "./${build}" >"$build_output" 2>&1
199     build_exit="$?"
200     if [ "$build_exit" = '0' ]; then
201         "./${run}" $run_args "$@" >"$output" 2>&1
202         sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
203         good="yes"
204     else
205         cat "$build_output" 1>&2
206         echo "build exit status: $build_exit" 1>&2
207     fi
208 else
209     "./${build}" >"$build_output" 2>&1
210     build_exit="$?"
211     if [ "$build_exit" = '0' ]; then
212         "./${run}" $run_args "$@" >"$output" 2>&1
213     else
214         cp "$build_output" "$output"
215         echo "build exit status: $build_exit" >>"$output"
216     fi
217     diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
218     if [ "$?" = "0" ]; then
219         # output == expected
220         good="yes"
221         echo "${test_dir}: succeeded!" 1>&2
222     fi
223 fi
224
225 if [ "$good" = "yes" ]; then
226     cd "$oldwd"
227     rm -rf "$tmp_dir"
228     exit 0
229 fi
230
231 (
232     if [ "$update_mode" '!=' "yes" ]; then
233         echo "${test_dir}: FAILED!"
234         echo ' '
235         echo '#################### info'
236         cat "${td_info}" | sed 's/^/# /g'
237         echo '#################### diffs'
238         diff --strip-trailing-cr -u "$expected" "$output"
239         echo '####################'
240         echo ' '
241     fi
242     echo "files left in ${tmp_dir}"
243 ) 1>&2
244
245 exit 1